VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "NAGI Font Editor"
   ClientHeight    =   3060
   ClientLeft      =   165
   ClientTop       =   900
   ClientWidth     =   4545
   Icon            =   "frmMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   204
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   303
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtCharEdit 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      Height          =   300
      Left            =   720
      TabIndex        =   7
      Top             =   405
      Width           =   480
   End
   Begin VB.CommandButton cmdCharList 
      Caption         =   "&Show Character Picker"
      Enabled         =   0   'False
      Height          =   480
      Left            =   225
      TabIndex        =   4
      Top             =   2025
      Width           =   1500
   End
   Begin VB.PictureBox picStatus 
      Align           =   2  'Align Bottom
      AutoRedraw      =   -1  'True
      Height          =   345
      Left            =   0
      ScaleHeight     =   19
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   299
      TabIndex        =   2
      Top             =   2715
      Width           =   4545
      Begin VB.Label lblSize 
         Alignment       =   1  'Right Justify
         Height          =   270
         Left            =   2790
         TabIndex        =   6
         Top             =   30
         Width           =   1620
      End
      Begin VB.Label lblPos 
         Height          =   270
         Left            =   60
         TabIndex        =   5
         Top             =   30
         Width           =   1620
      End
   End
   Begin VB.PictureBox picPreview 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   720
      ScaleHeight     =   29
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   28
      TabIndex        =   1
      Top             =   960
      Width           =   480
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picEdit 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   2460
      Left            =   1995
      ScaleHeight     =   160
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   160
      TabIndex        =   0
      Top             =   135
      Width           =   2460
   End
   Begin VB.Label lblCharName 
      Alignment       =   2  'Center
      Height          =   450
      Left            =   60
      TabIndex        =   8
      Top             =   1530
      Width           =   1920
   End
   Begin VB.Label lblEdit 
      Caption         =   "Current Character Code:"
      Height          =   240
      Left            =   150
      TabIndex        =   3
      Top             =   165
      Width           =   1800
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuFNew 
         Caption         =   "&New"
         Begin VB.Menu mnuFNNew 
            Caption         =   "&4 x 8 Font Size	Ctrl+F"
            Index           =   0
         End
         Begin VB.Menu mnuFNNew 
            Caption         =   "&8 x 8 Font Size	Ctrl+E"
            Index           =   1
         End
         Begin VB.Menu mnuFNNew 
            Caption         =   "&16 x 16 Font Size	Ctrl+N"
            Index           =   2
         End
      End
      Begin VB.Menu mnuFOpen 
         Caption         =   "&Open	Ctrl+O"
      End
      Begin VB.Menu mnuFSpace0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFSave 
         Caption         =   "&Save	Ctrl+S"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuFSaveAs 
         Caption         =   "Save &As ..."
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuFSpace1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFQuit 
         Caption         =   "Quit	Ctrl+Q"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "Edit"
      Begin VB.Menu mnuECut 
         Caption         =   "Cu&t	Ctrl+X"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuECopy 
         Caption         =   "&Copy	Ctrl+C"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuEPaste 
         Caption         =   "&Paste	Ctrl+V"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuESpace0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEClear 
         Caption         =   "C&lear	Del"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHContents 
         Caption         =   "&Contents	F1"
      End
      Begin VB.Menu mnuHAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Dirty As Boolean
Public FontFileName As String

Public CurrentChar As Byte
Private CharEditData(15, 15) As Byte

Private CurX As Long, CurY As Long
Private SelX As Long, SelY As Long

Private ClipData(31) As Byte
Private CanPaste As Boolean
Private Sub ConfigureEditor(ByVal CharWidth As Byte)

  Dim i As Long, j As Long
  
  On Error GoTo ErrHandler
  
  picEdit.Cls
  
  Select Case CharWidth
  Case 4
    'draw a grid of 8 x 8
    For i = 1 To 7
      picEdit.Line (0, i * 20)-(160, i * 20), &HC0C0C0
      picEdit.Line (i * 20, 0)-(i * 20, 160), &HC0C0C0
    Next i
    'grey out two columns on right and two on left
    picEdit.DrawStyle = 0
    picEdit.Line (0, 0)-(40, 160), &HC0C0C0, BF
    picEdit.Line (120, 0)-(160, 160), &HC0C0C0, BF
  
  Case 8
    'draw a grid of 8 x 8
    For i = 1 To 7
      picEdit.Line (0, i * 20)-(160, i * 20), &HC0C0C0
      picEdit.Line (i * 20, 0)-(i * 20, 160), &HC0C0C0
    Next i
  
  Case 16
    'draw grid of 16 x 16
    
    For i = 1 To 15
      picEdit.Line (0, i * 10)-(160, i * 10), &HC0C0C0
      picEdit.Line (i * 10, 0)-(i * 10, 160), &HC0C0C0
    Next i
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub EditChar(ByVal CharVal As Byte)

  Dim i As Long, j As Long
  Dim lngVal1 As Long, lngVal2 As Long
  Dim lngColor As Long
  Dim Me_hDC As Long
  
  On Error GoTo ErrHandler
  
  'now we have a character to edit!
  CurrentChar = CharVal
  
  txtCharEdit.Text = "0x" & Hex2(CurrentChar)
  Me.lblCharName = strCharText(CurrentChar)
  
  'if not previously in use
  If Not CharUsed(CurrentChar) Then
    'toggle it
    CharUsed(CurrentChar) = True
    'clear the cel on the charpicker
    frmCharPicker.picSelect.Line ((CurrentChar Mod 16) * 19 + 2, ((CurrentChar \ 16)) * 19 + 2)-Step(15, 15), vbWhite, BF
  End If
  
  Me_hDC = picPreview.hdc
  'select it on the charpicker
  frmCharPicker.SelectChar CurrentChar Mod 16, CurrentChar \ 16
  
  Select Case CharWidth
  Case 4
    For j = 0 To 7
      lngVal1 = CharData(CharVal, j) \ 16
      
      For i = 3 To 0 Step -1
        'extract all four bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        picEdit.Line (i * 20 + 41, j * 20 + 1)-Step(18, 18), lngColor, BF
        SetPixelV Me_hDC, 12 + i, 11 + j, lngColor
        
        lngVal1 = lngVal1 \ 2
     Next i
    Next j
  Case 8
    For j = 0 To 7
      lngVal1 = CharData(CharVal, j)
      
      For i = 7 To 0 Step -1
        'extract all eight bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        picEdit.Line (i * 20 + 1, j * 20 + 1)-Step(18, 18), lngColor, BF
        SetPixelV Me_hDC, 10 + i, 11 + j, lngColor
        
        lngVal1 = lngVal1 \ 2
     Next i
    Next j
  Case 16
    
    For j = 0 To 15
      lngVal1 = CharData(CharVal, j * 2)
      lngVal2 = CharData(CharVal, j * 2 + 1)
      
      For i = 7 To 0 Step -1
        'extract all sixteen bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        picEdit.Line (i * 10 + 1, j * 10 + 1)-Step(8, 8), lngColor, BF
        SetPixelV Me_hDC, 6 + i, 7 + j, lngColor
        
        lngColor = ((lngVal2 And 1) - 1) And &HFFFFFF
        picEdit.Line ((i + 8) * 10 + 1, j * 10 + 1)-Step(8, 8), lngColor, BF
        SetPixelV Me_hDC, 14 + i, 7 + j, lngColor
        
        lngVal1 = lngVal1 \ 2
        lngVal2 = lngVal2 \ 2
     Next i
    Next j
    
  End Select
  
  picPreview.Refresh
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub ResetCharPixel()

  Dim bytMask As Byte
  Dim bytByte As Byte
  
  On Error GoTo ErrHandler
  
  'set bit
  Select Case CharWidth
  Case 4
    'convert curx, cury into bit
    bytByte = CurY
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if already set,
    If CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) And Not bytMask
      
      'update the grid
      picEdit.Line (CurX * 20 + 41, CurY * 20 + 1)-Step(18, 18), vbWhite, BF
      'update the preview
      SetPixelV picPreview.hdc, 12 + CurX, 11 + CurY, vbWhite
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbWhite
    End If
  Case 8
    'convert curx, cury into bit
    bytByte = CurY
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if already set,
    If CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) And Not bytMask
      
      'update the grid
      picEdit.Line (CurX * 20 + 1, CurY * 20 + 1)-Step(18, 18), vbWhite, BF
      'update the preview
      SetPixelV picPreview.hdc, 10 + CurX, 11 + CurY, vbWhite
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbWhite
    End If
  Case 16
    'convert curx, cury into bit
    bytByte = CurX \ 8 + CurY * 2
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if already set,
    If CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) And Not bytMask
      
      'update the grid
      picEdit.Line (CurX * 10 + 1, CurY * 10 + 1)-Step(8, 8), vbWhite, BF
      'update the preview
      SetPixelV picPreview.hdc, 6 + CurX, 7 + CurY, vbWhite
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbWhite
    End If
  End Select
    
  Me.Dirty = True
  
  'update selection
  SelX = CurX
  SelY = CurY
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Function SaveCurrentFile(Optional ByVal SaveAs As Boolean = False) As Boolean

'  'if not dirty
'  If Not Me.Dirty Then
'    Exit Sub
'  End If
  
  On Error Resume Next
  
  'if no filename
  If Len(Me.FontFileName) = 0 Or SaveAs Then
    'get a filename
    CommonDialog1.FileName = FontFileName
    CommonDialog1.DialogTitle = "Save NAGI Font File"
    CommonDialog1.ShowSave
    If Err.Number = cdlCancel Then
      Exit Function
    End If
    FontFileName = CommonDialog1.FileName
  End If
  
  If SaveFontFile(FontFileName) Then
    'reset dirty flag
    Me.Dirty = False
    'reset caption
    Me.Caption = "NAGI Font Editor - " & JustFileName(FontFileName)
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Private Sub SetCharPixel()

  Dim bytMask As Byte
  Dim bytByte As Byte
  
  
  On Error GoTo ErrHandler
  
  'set bit
  Select Case CharWidth
  Case 4
    'convert curx, cury into bit
    bytByte = CurY
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if not already set,
    If Not CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) Or bytMask
      
      'update the grid
      picEdit.Line (CurX * 20 + 41, CurY * 20 + 1)-Step(18, 18), vbBlack, BF
      'update the preview
      SetPixelV picPreview.hdc, 12 + CurX, 11 + CurY, vbBlack
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbBlack
    End If
  Case 8
    'convert curx, cury into bit
    bytByte = CurY
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if not already set,
    If Not CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) Or bytMask
      
      'update the grid
      picEdit.Line (CurX * 20 + 1, CurY * 20 + 1)-Step(18, 18), vbBlack, BF
      'update the preview
      SetPixelV picPreview.hdc, 10 + CurX, 11 + CurY, vbBlack
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbBlack
    End If
  Case 16
    'convert curx, cury into bit
    bytByte = CurX \ 8 + CurY * 2
    bytMask = 2 ^ (7 - (CurX Mod 8))
    'if not already set,
    If Not CharData(CurrentChar, bytByte) And bytMask Then
      CharData(CurrentChar, bytByte) = CharData(CurrentChar, bytByte) Or bytMask
      
      'update the grid
      picEdit.Line (CurX * 10 + 1, CurY * 10 + 1)-Step(8, 8), vbBlack, BF
      'update the preview
      SetPixelV picPreview.hdc, 6 + CurX, 7 + CurY, vbBlack
      picPreview.Refresh
      'update the charpicker
      frmCharPicker.SetPixel CurrentChar, CurX, CurY, vbBlack
    End If
  End Select
      
  Me.Dirty = True
    
  'update selection
  SelX = CurX
  SelY = CurY
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub SetCurrentPos(ByVal X As Single, ByVal Y As Single)

  On Error GoTo ErrHandler
  
  Select Case CharWidth
  Case 4
    CurX = X \ 20 - 2
    CurY = Y \ 20
  Case 8
    CurX = X \ 20
    CurY = Y \ 20
  Case 16
    CurX = X \ 10
    CurY = Y \ 10
  End Select
  
  'set bounds
  If CurX < 0 Then
    CurX = 0
  End If
  If CurX > CharWidth - 1 Then
    CurX = CharWidth - 1
  End If
  If CurY < 0 Then
    CurY = 0
  End If
  If CurY > CharHeight - 1 Then
    CurY = CharHeight - 1
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub cmdCharList_Click()

  On Error GoTo ErrHandler
  
  'toggle the character list
  
  If InStr(cmdCharList.Caption, "Show") > 0 Then
    'picker is hidden, or unloaded
    Load frmCharPicker
    'if this is first time
    If Not PickerPos Then
      'default to just below
      frmCharPicker.Move Me.Left, Me.Top + Me.Height
    Else
      'use last pos
      frmCharPicker.Move PickerLeft, PickerTop
    End If
    frmCharPicker.Show vbModeless, Me
    cmdCharList.Caption = "&Hide Character Picker"
  Else
    'picker is visible; hide it
    'save positions
    PickerLeft = frmCharPicker.Left
    PickerTop = frmCharPicker.Top
    frmCharPicker.Hide
    cmdCharList.Caption = "&Show Character Picker"
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  On Error GoTo ErrHandler
  
  Select Case Shift
  Case 0  'none
    Select Case KeyCode
    Case vbKeyDelete
      mnuEClear_Click
    Case vbKeyF1
      mnuHContents_Click
    End Select
  Case vbCtrlMask
    Select Case KeyCode
    Case vbKeyF
      mnuFNNew_Click 0
    Case vbKeyE
      mnuFNNew_Click 1
    Case vbKeyN
      mnuFNNew_Click 2
    Case vbKeyO
      mnuFOpen_Click
    Case vbKeyS
      mnuFSave_Click
    Case vbKeyQ
      mnuFQuit_Click
    Case vbKeyX
      mnuECut_Click
    Case vbKeyC
      mnuECopy_Click
    Case vbKeyV
      mnuEPaste_Click
    End Select
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Load()

  Dim rtn As Long
  
  On Error GoTo ErrHandler
  
  'initialize
  strCharText(0) = "Null"
  strCharText(1) = "Start of Heading"
  strCharText(2) = "Start of Text"
  strCharText(3) = "End of Text"
  strCharText(4) = "End of Transmission"
  strCharText(5) = "Enquiry"
  strCharText(6) = "Acknowledge"
  strCharText(7) = "Bell"
  strCharText(8) = "Backspace"
  strCharText(9) = "Horizontal Tabulation"
  strCharText(10) = "Line Feed"
  strCharText(11) = "Vertical Tabulation"
  strCharText(12) = "Form Feed"
  strCharText(13) = "Carriage Return"
  strCharText(14) = "Shift Out"
  strCharText(15) = "Shift In"
  strCharText(16) = "Data Link Escape"
  strCharText(17) = "Device Control One"
  strCharText(18) = "Device Control Two"
  strCharText(19) = "Device Control Three"
  strCharText(20) = "Device Control Four"
  strCharText(21) = "Negative Acknowledge"
  strCharText(22) = "Synchronous Idle"
  strCharText(23) = "End of Transmission Block"
  strCharText(24) = "Cancel"
  strCharText(25) = "End of Medium"
  strCharText(26) = "Substitute"
  strCharText(27) = "Escape"
  strCharText(28) = "File Separator"
  strCharText(29) = "Group Separator"
  strCharText(30) = "Record Separator"
  strCharText(31) = "Unit Separator"
  strCharText(32) = "Space"
  strCharText(33) = "Exclamation Mark"
  strCharText(34) = "Quotation Mark"
  strCharText(35) = "Number Sign"
  strCharText(36) = "Dollar Sign"
  strCharText(37) = "Percent Sign"
  strCharText(38) = "Ampersand"
  strCharText(39) = "Apostrophe"
  strCharText(40) = "Left Parenthesis"
  strCharText(41) = "Right Parenthesis"
  strCharText(42) = "Asterisk"
  strCharText(43) = "Plus Sign"
  strCharText(44) = "Comma"
  strCharText(45) = "Hyphen-Minus"
  strCharText(46) = "Full Stop"
  strCharText(47) = "Solidus"
  strCharText(48) = "Digit Zero"
  strCharText(49) = "Digit One"
  strCharText(50) = "Digit Two"
  strCharText(51) = "Digit Three"
  strCharText(52) = "Digit Four"
  strCharText(53) = "Digit Five"
  strCharText(54) = "Digit Six"
  strCharText(55) = "Digit Seven"
  strCharText(56) = "Digit Eight"
  strCharText(57) = "Digit Nine"
  strCharText(58) = "Colon"
  strCharText(59) = "Semicolon"
  strCharText(60) = "Less-Than Sign"
  strCharText(61) = "Equals Sign"
  strCharText(62) = "Greater-Than Sign"
  strCharText(63) = "Question Mark"
  strCharText(64) = "Commercial At"
  strCharText(65) = "Latin Capital Letter A"
  strCharText(66) = "Latin Capital Letter B"
  strCharText(67) = "Latin Capital Letter C"
  strCharText(68) = "Latin Capital Letter D"
  strCharText(69) = "Latin Capital Letter E"
  strCharText(70) = "Latin Capital Letter F"
  strCharText(71) = "Latin Capital Letter G"
  strCharText(72) = "Latin Capital Letter H"
  strCharText(73) = "Latin Capital Letter I"
  strCharText(74) = "Latin Capital Letter J"
  strCharText(75) = "Latin Capital Letter K"
  strCharText(76) = "Latin Capital Letter L"
  strCharText(77) = "Latin Capital Letter M"
  strCharText(78) = "Latin Capital Letter N"
  strCharText(79) = "Latin Capital Letter O"
  strCharText(80) = "Latin Capital Letter P"
  strCharText(81) = "Latin Capital Letter Q"
  strCharText(82) = "Latin Capital Letter R"
  strCharText(83) = "Latin Capital Letter S"
  strCharText(84) = "Latin Capital Letter T"
  strCharText(85) = "Latin Capital Letter U"
  strCharText(86) = "Latin Capital Letter V"
  strCharText(87) = "Latin Capital Letter W"
  strCharText(88) = "Latin Capital Letter X"
  strCharText(89) = "Latin Capital Letter Y"
  strCharText(90) = "Latin Capital Letter Z"
  strCharText(91) = "Left Square Bracket"
  strCharText(92) = "Reverse Solidus"
  strCharText(93) = "Right Square Bracket"
  strCharText(94) = "Circumflex Accent"
  strCharText(95) = "Low Line"
  strCharText(96) = "Grave Accent"
  strCharText(97) = "Latin Small Letter A"
  strCharText(98) = "Latin Small Letter B"
  strCharText(99) = "Latin Small Letter C"
  strCharText(100) = "Latin Small Letter D"
  strCharText(101) = "Latin Small Letter E"
  strCharText(102) = "Latin Small Letter F"
  strCharText(103) = "Latin Small Letter G"
  strCharText(104) = "Latin Small Letter H"
  strCharText(105) = "Latin Small Letter I"
  strCharText(106) = "Latin Small Letter J"
  strCharText(107) = "Latin Small Letter K"
  strCharText(108) = "Latin Small Letter L"
  strCharText(109) = "Latin Small Letter M"
  strCharText(110) = "Latin Small Letter N"
  strCharText(111) = "Latin Small Letter O"
  strCharText(112) = "Latin Small Letter P"
  strCharText(113) = "Latin Small Letter Q"
  strCharText(114) = "Latin Small Letter R"
  strCharText(115) = "Latin Small Letter S"
  strCharText(116) = "Latin Small Letter T"
  strCharText(117) = "Latin Small Letter U"
  strCharText(118) = "Latin Small Letter V"
  strCharText(119) = "Latin Small Letter W"
  strCharText(120) = "Latin Small Letter X"
  strCharText(121) = "Latin Small Letter Y"
  strCharText(122) = "Latin Small Letter Z"
  strCharText(123) = "Left Curly Bracket"
  strCharText(124) = "Vertical Line"
  strCharText(125) = "Right Curly Bracket"
  strCharText(126) = "Tilde"
  strCharText(127) = "Delete"
  strCharText(128) = "Euro Sign"
  strCharText(129) = "{undefined}"
  strCharText(130) = "Single Low-9 Quotation Mark"
  strCharText(131) = "Latin Small Letter F with Hook"
  strCharText(132) = "Double Low-9 Quotation Mark"
  strCharText(133) = "Horizontal Ellipsis"
  strCharText(134) = "Dagger"
  strCharText(135) = "Double Dagger"
  strCharText(136) = "Modifier Letter Circumflex Accent"
  strCharText(137) = "Per Mille Sign"
  strCharText(138) = "Latin Capital Letter S with Caron"
  strCharText(139) = "Single Left-Pointing Angle Quotation Mark"
  strCharText(140) = "Latin Capital Ligature Oe"
  strCharText(141) = "{undefined}"
  strCharText(142) = "Latin Capital Letter Z with Caron"
  strCharText(143) = "{undefined}"
  strCharText(144) = "{undefined}"
  strCharText(145) = "Left Single Quotation Mark"
  strCharText(146) = "Right Single Quotation Mark"
  strCharText(147) = "Left Double Quotation Mark"
  strCharText(148) = "Right Double Quotation Mark"
  strCharText(149) = "Bullet"
  strCharText(150) = "En Dash"
  strCharText(151) = "Em Dash"
  strCharText(152) = "Small Tilde"
  strCharText(153) = "Trade Mark Sign"
  strCharText(154) = "Latin Small Letter S with Caron"
  strCharText(155) = "Single Right-Pointing Angle Quotation Mark"
  strCharText(156) = "Latin Small Ligature Oe"
  strCharText(157) = "{undefined}"
  strCharText(158) = "Latin Small Letter Z with Caron"
  strCharText(159) = "Latin Capital Letter Y with Diaeresis"
  strCharText(160) = "No-Break Space"
  strCharText(161) = "Inverted Exclamation Mark"
  strCharText(162) = "Cent Sign"
  strCharText(163) = "Pound Sign"
  strCharText(164) = "Currency Sign"
  strCharText(165) = "Yen Sign"
  strCharText(166) = "Broken Bar"
  strCharText(167) = "Section Sign"
  strCharText(168) = "Diaeresis"
  strCharText(169) = "Copyright Sign"
  strCharText(170) = "Feminine Ordinal Indicator"
  strCharText(171) = "Left-Pointing Double Angle Quotation Mark"
  strCharText(172) = "Not Sign"
  strCharText(173) = "Soft Hyphen"
  strCharText(174) = "Registered Sign"
  strCharText(175) = "Macron"
  strCharText(176) = "Degree Sign"
  strCharText(177) = "Plus-Minus Sign"
  strCharText(178) = "Superscript Two"
  strCharText(179) = "Superscript Three"
  strCharText(180) = "Acute Accent"
  strCharText(181) = "Micro Sign"
  strCharText(182) = "Pilcrow Sign"
  strCharText(183) = "Middle Dot"
  strCharText(184) = "Cedilla"
  strCharText(185) = "Superscript One"
  strCharText(186) = "Masculine Ordinal Indicator"
  strCharText(187) = "Right-Pointing Double Angle Quotation Mark"
  strCharText(188) = "Vulgar Fraction One Quarter"
  strCharText(189) = "Vulgar Fraction One Half"
  strCharText(190) = "Vulgar Fraction Three Quarters"
  strCharText(191) = "Inverted Question Mark"
  strCharText(192) = "Latin Capital Letter A with Grave"
  strCharText(193) = "Latin Capital Letter A with Acute"
  strCharText(194) = "Latin Capital Letter A with Circumflex"
  strCharText(195) = "Latin Capital Letter A with Tilde"
  strCharText(196) = "Latin Capital Letter A with Diaeresis"
  strCharText(197) = "Latin Capital Letter A with Ring Above"
  strCharText(198) = "Latin Capital Letter Ae"
  strCharText(199) = "Latin Capital Letter C with Cedilla"
  strCharText(200) = "Latin Capital Letter E with Grave"
  strCharText(201) = "Latin Capital Letter E with Acute"
  strCharText(202) = "Latin Capital Letter E with Circumflex"
  strCharText(203) = "Latin Capital Letter E with Diaeresis"
  strCharText(204) = "Latin Capital Letter I with Grave"
  strCharText(205) = "Latin Capital Letter I with Acute"
  strCharText(206) = "Latin Capital Letter I with Circumflex"
  strCharText(207) = "Latin Capital Letter I with Diaeresis"
  strCharText(208) = "Latin Capital Letter Eth"
  strCharText(209) = "Latin Capital Letter N with Tilde"
  strCharText(210) = "Latin Capital Letter O with Grave"
  strCharText(211) = "Latin Capital Letter O with Acute"
  strCharText(212) = "Latin Capital Letter O with Circumflex"
  strCharText(213) = "Latin Capital Letter O with Tilde"
  strCharText(214) = "Latin Capital Letter O with Diaeresis"
  strCharText(215) = "Multiplication Sign"
  strCharText(216) = "Latin Capital Letter O with Stroke"
  strCharText(217) = "Latin Capital Letter U with Grave"
  strCharText(218) = "Latin Capital Letter U with Acute"
  strCharText(219) = "Latin Capital Letter U with Circumflex"
  strCharText(220) = "Latin Capital Letter U with Diaeresis"
  strCharText(221) = "Latin Capital Letter Y with Acute"
  strCharText(222) = "Latin Capital Letter Thorn"
  strCharText(223) = "Latin Small Letter Sharp S"
  strCharText(224) = "Latin Small Letter A with Grave"
  strCharText(225) = "Latin Small Letter A with Acute"
  strCharText(226) = "Latin Small Letter A with Circumflex"
  strCharText(227) = "Latin Small Letter A with Tilde"
  strCharText(228) = "Latin Small Letter A with Diaeresis"
  strCharText(229) = "Latin Small Letter A with Ring Above"
  strCharText(230) = "Latin Small Letter Ae"
  strCharText(231) = "Latin Small Letter C with Cedilla"
  strCharText(232) = "Latin Small Letter E with Grave"
  strCharText(233) = "Latin Small Letter E with Acute"
  strCharText(234) = "Latin Small Letter E with Circumflex"
  strCharText(235) = "Latin Small Letter E with Diaeresis"
  strCharText(236) = "Latin Small Letter I with Grave"
  strCharText(237) = "Latin Small Letter I with Acute"
  strCharText(238) = "Latin Small Letter I with Circumflex"
  strCharText(239) = "Latin Small Letter I with Diaeresis"
  strCharText(240) = "Latin Small Letter Eth"
  strCharText(241) = "Latin Small Letter N with Tilde"
  strCharText(242) = "Latin Small Letter O with Grave"
  strCharText(243) = "Latin Small Letter O with Acute"
  strCharText(244) = "Latin Small Letter O with Circumflex"
  strCharText(245) = "Latin Small Letter O with Tilde"
  strCharText(246) = "Latin Small Letter O with Diaeresis"
  strCharText(247) = "Division Sign"
  strCharText(248) = "Latin Small Letter O with Stroke"
  strCharText(249) = "Latin Small Letter U with Grave"
  strCharText(250) = "Latin Small Letter U with Acute"
  strCharText(251) = "Latin Small Letter U with Circumflex"
  strCharText(252) = "Latin Small Letter U with Diaeresis"
  strCharText(253) = "Latin Small Letter Y with Acute"
  strCharText(254) = "Latin Small Letter Thorn"
  strCharText(255) = "Latin Small Letter Y with Diaeresis"
  
  'set up open/save dialog
  With CommonDialog1
    .CancelError = True
    .Filter = "NAGI Fonts (*.nbf)|*.nbf|All Files (*.*)|*.*"
    .FilterIndex = 0
    .DefaultExt = "nbf"
  End With

  'get reference to temporary directory
  rtn = GetTempPath(1&, TempDir)
  'if successful,
  If rtn <> 0 Then
    'call function again with correct length
    TempDir = String$(rtn, " ")
    rtn = GetTempPath(rtn, TempDir)
    'if successful,
    If rtn <> 0 Then
      'strip null char off end
      TempDir = Left(TempDir, Len(TempDir) - 1)
    Else
      'if tempdir not found, use current directory
      TempDir = CurDir()
    End If
  Else
    'if tempdir not found, use current directory
    TempDir = CurDir()
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'if dirty,
  If Me.Dirty Then
    'ask if should save first
    rtn = MsgBox("Do you want to save changes to the current font file?", vbQuestion + vbYesNoCancel, "Save Font File?")
    If rtn = vbYes Then
      If Not SaveFontFile(FontFileName) Then
        rtn = MsgBox("File not saved due to error. Quit anyway?", vbCritical + vbYesNo, "Save File Error")
        If rtn = vbNo Then
          rtn = vbCancel
        End If
      End If
    End If
        
    'cancel the save
    If rtn = vbCancel Then
      Cancel = True
      Exit Sub
    End If
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Unload(Cancel As Integer)

  'unload picker too
  Unload frmCharPicker
End Sub


Private Sub mnuEClear_Click()

  'clear the character
  
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'if text box has focus, just exit
  If ActiveControl.Name = "txtCharEdit" Then
    Exit Sub
  End If
  
  For i = 0 To 31
    CharData(CurrentChar, i) = 0
  Next i
  
  'clear preview
  picPreview.Cls
  
  'clear drawing area
  ConfigureEditor CharWidth
  
  'clear item on picker
  frmCharPicker.picSelect.Line ((CurrentChar Mod 16) * 19 + 2, (CurrentChar \ 16) * 19 + 2)-Step(15, 15), vbWhite, BF
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub mnuECopy_Click()

  'put data onto the clipboard
  
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'if text box has focus, just exit
  If ActiveControl.Name = "txtCharEdit" Then
    Exit Sub
  End If
  
  For i = 0 To 31
    ClipData(i) = CharData(CurrentChar, i)
  Next i
  
  'enable pasting
  CanPaste = True
  mnuEPaste.Enabled = True
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub mnuECut_Click()

  On Error GoTo ErrHandler
  
  'if text box has focus, just exit
  If ActiveControl.Name = "txtCharEdit" Then
    Exit Sub
  End If
    
  'copy...
  mnuECopy_Click
  
  'then clear
  mnuEClear_Click
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Private Sub mnuEPaste_Click()

  On Error GoTo ErrHandler
  
  'copy data from clipboard
  
  Dim i As Long
  
  'if text box has focus, just exit
  If ActiveControl.Name = "txtCharEdit" Then
    Exit Sub
  End If
  
  For i = 0 To 31
    CharData(CurrentChar, i) = ClipData(i)
  Next i
  
  'edit char to force update
  EditChar CurrentChar
  'and update picker, as well
  frmCharPicker.DrawChar CurrentChar
  'mark as dirty
  Me.Dirty = True
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub mnuFNNew_Click(Index As Integer)

  'similar to open
  
  On Error Resume Next
  Dim rtn As VbMsgBoxResult
  Dim i As Long, j As Long
  
  If Me.Dirty Then
    'ask to save first
    rtn = MsgBox("Do you want to save changes to the current font file?", vbQuestion + vbYesNoCancel, "Save Font File?")
    If rtn = vbYes Then
      If Not SaveFontFile(FontFileName) Then
        rtn = vbCancel
      End If
    End If
    
    If rtn = vbCancel Then
      Exit Sub
    End If
  End If
  
  'clear out variables
  For i = 0 To 255
    CharUsed(i) = False
    For j = 0 To 31
      CharData(i, j) = 0
    Next j
  Next i
  
  'set size depending on index
  Select Case Index
  Case 0  '4x8
    CharWidth = 4
    CharHeight = 8
    BytesPerChar = 8
    lblSize.Caption = "Size: 4 x 8"
  Case 1  '8x8
    CharWidth = 8
    CharHeight = 8
    BytesPerChar = 8
    lblSize.Caption = "Size: 8 x 8"
  Case 2  '16x16
    CharWidth = 16
    CharHeight = 16
    BytesPerChar = 32
    lblSize.Caption = "Size: 16 x 16"
  End Select
  
  'reset dirty flag
  Me.Dirty = False
  'blank out name
  FontFileName = vbNullString
  'set caption
  Me.Caption = "NAGI Font Editor - New Font"
  
  'configure edit window
  ConfigureEditor CharWidth
  'clear preview
  picPreview.Cls
  
  'redraw picker
  frmCharPicker.DrawCharsOnGrid
  
  'enable selector button
  cmdCharList.Enabled = True
  'enable char text box
  txtCharEdit.Enabled = True
  'reset selected char
  CurrentChar = 33
  EditChar CurrentChar
  
  'disable pasting
  CanPaste = False
  mnuEPaste.Enabled = False
  'enable other editing options
  mnuECut.Enabled = True
  mnuECopy.Enabled = True
  mnuEClear.Enabled = True
  mnuFSave.Enabled = True
  mnuFSaveAs.Enabled = True
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub mnuFOpen_Click()

  On Error Resume Next
  
  Dim rtn As VbMsgBoxResult
  Dim i As Long, j As Long
  
  CommonDialog1.DialogTitle = "Open NAGI Font File"
  CommonDialog1.FileName = vbNullString
  CommonDialog1.ShowOpen
  
  If Err.Number = cdlCancel Then
    Exit Sub
  End If
  
  If Me.Dirty Then
    'ask to save first?
    rtn = MsgBox("Do you want to save changes to the current font file?", vbQuestion + vbYesNoCancel, "Save Font File?")
    If rtn = vbYes Then
      If Not SaveFontFile(FontFileName) Then
        rtn = vbCancel
      End If
    End If
    If rtn = vbCancel Then
      Exit Sub
    End If
  End If
  
  'clear out variables
  For i = 0 To 255
    CharUsed(i) = False
    For j = 0 To 31
      CharData(i, j) = 0
    Next j
  Next i
  
  If Not LoadFont(CommonDialog1.FileName) Then
    MsgBox "Unable to load this file. It does not appear to be a valid NAGI font file.", vbCritical + vbOKOnly, "Unable to Load File"
    Exit Sub
  End If
  
  'reset dirty flag
  Me.Dirty = False
  'save name
  FontFileName = CommonDialog1.FileName
  'set caption
  Me.Caption = "NAGI Font Editor - " & JustFileName(FontFileName)
  
  'set size caption
  Select Case CharWidth
  Case 4
    lblSize.Caption = "Size: 4 x 8"
  Case 8
    lblSize.Caption = "Size: 8 x 8"
  Case 16
    lblSize.Caption = "Size: 16 x 16"
  End Select
  
  'configure edit window
  ConfigureEditor CharWidth
  'clear preview
  picPreview.Cls
  
  'enable selector button
  cmdCharList.Enabled = True
  'enable char text box
  txtCharEdit.Enabled = True
  'reset selected char to first char in use
  For i = 0 To 255
    If CharUsed(i) Then
      CurrentChar = i
      Exit For
    End If
  Next i
  If i = 256 Then
    'use char 33
    CurrentChar = 33
  End If
  EditChar CurrentChar
  
  'empty clipboard
  CanPaste = False
  mnuEPaste.Enabled = False
  'enable other editing options
  mnuECut.Enabled = True
  mnuECopy.Enabled = True
  mnuEClear.Enabled = True
  mnuFSave.Enabled = True
  mnuFSaveAs.Enabled = True
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Private Sub mnuFQuit_Click()

  Unload Me
End Sub

Private Sub mnuFSave_Click()
  
  SaveCurrentFile
End Sub


Private Sub mnuFSaveAs_Click()

  SaveCurrentFile True
End Sub


Private Sub mnuHAbout_Click()

  frmAbout.Show vbModal, Me
End Sub
Private Sub mnuHContents_Click()

  Load frmHelp
  'if this is first time
  If Not HelpPos Then
    'default to right
    frmHelp.Move Me.Left + Me.Width, Me.Top
  Else
    'use last pos
    frmHelp.Move HelpLeft, HelpTop
  End If
  frmHelp.Show
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picEdit_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  On Error GoTo ErrHandler
  
  If CurrentChar = 0 Then
    'should never get here...
    Debug.Assert False
    Exit Sub
  End If
  
  'set current cursor pos
  SetCurrentPos X, Y
  
  'set/clear bit, depending on what was clicked
  Select Case Button
  Case vbLeftButton
    SetCharPixel
    
  Case vbRightButton
    ResetCharPixel
    
  End Select
  
  'set selection
  SelX = CurX
  SelY = CurY

Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub picEdit_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  On Error GoTo ErrHandler
  
  If CurrentChar = 0 Then
    'should never get here...
    Debug.Assert False
    Exit Sub
  End If
  
  'set current cursor pos
  SetCurrentPos X, Y
  
  'update statusbar
  lblPos.Caption = "X: " & CurX & "   Y: " & CurY
  
  'if dragging a selection,
  Select Case Button
  Case vbLeftButton
    'if current pos is different from selected pos
    If CurX <> SelX Or CurY <> SelY Then
      SetCharPixel
    End If
  
  Case vbRightButton
    'if current pos is different from selected pos
    If CurX <> SelX Or CurY <> SelY Then
      ResetCharPixel
    End If
  End Select
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtCharEdit_KeyDown(KeyCode As Integer, Shift As Integer)

  'only certain keys allowed
  Dim strText As String
  Dim bytNewChar As Byte
  
  On Error GoTo ErrHandler
  
  Select Case KeyCode
  Case vbKeyReturn
    'selects the entered character
    strText = txtCharEdit.Text
    If Left$(strText, 2) = "0x" Then
      strText = Right$(strText, Len(strText) - 2)
      bytNewChar = CByte(Val("&H" & strText))
    Else
      bytNewChar = CByte(Val(strText))
    End If
    
    EditChar bytNewChar
    picEdit.SetFocus
    
  Case vbKeyBack, vbKeyDelete, vbKeyRight, vbKeyLeft
    'allow em
    
  Case vbKey0 To vbKey9
    'no shift
    If Shift <> 0 Then
      KeyCode = 0
    End If
    
  Case vbKeyA To vbKeyF, vbKeyX
    'also allowed
  Case Else
    KeyCode = 0
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub txtCharEdit_KeyPress(KeyAscii As Integer)

  'valid entries are decimal numbers w/o "0x" prefix
  'OR hex numbers with "0x" prefix
  
  On Error GoTo ErrHandler
  
  'if first two chars are already "0x"
  If Left$(txtCharEdit.Text, 2) = "0x" Then
    'allow up to two hexadecimal characters
    If Len(txtCharEdit.Text) = 4 And KeyAscii <> 8 Then
      'too many
      KeyAscii = 0
      Exit Sub
    End If
    'only numbers and letters 'A-F' allowed
    Select Case KeyAscii
    Case 8, 48 To 57, 65 To 70
      'backspace,numbers, A-F allowed
    Case 97 To 102
      'convert to upper case
      KeyAscii = KeyAscii - 32
    Case Else
      KeyAscii = 0
    End Select
    
  'if we have a zero,
  ElseIf txtCharEdit.Text = "0" Then
    'allow numbers, or 'x'
    Select Case KeyAscii
    Case 8, 48 To 57, 120
      'allow backspace, numbers, or 'x'
    Case 88
      'convert to lower case
      KeyAscii = KeyAscii + 32
    Case Else
      'ignore
      KeyAscii = 0
    End Select
    
  Else
    'only backspace or numbers allowed
    Select Case KeyAscii
    Case 8
      'allowed
    Case 48 To 57
      'if newvalue is >255
      If Val(txtCharEdit.Text & Chr$(KeyAscii)) > 255 Then
        KeyAscii = 0
      End If
    
    Case Else
      KeyAscii = 0
    End Select
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
